    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Interface java.sql.DatabaseMetaData

public interface DatabaseMetaData

This class provides information about the database as a whole.

Many of the methods here return lists of information in ResultSets. You can use the normal ResultSet methods such as getString and getInt to retrieve the data from these ResultSets. If a given form of metadata is not available, these methods should throw a SQLException.

Some of these methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to a null ref, it means that argument's criteria should be dropped from the search.

A SQLException will be thrown if a driver does not support a meta data method. In the case of methods that return a ResultSet, either a ResultSet (which may be empty) is returned or a SQLException is thrown.

##

bestRowNotPseudo
  BEST ROW PSEUDO_COLUMN - is NOT a pseudo column.
bestRowPseudo
  BEST ROW PSEUDO_COLUMN - is a pseudo column.
bestRowSession
  BEST ROW SCOPE - valid for remainder of current session.
bestRowTemporary
  BEST ROW SCOPE - very temporary, while using row.
bestRowTransaction
  BEST ROW SCOPE - valid for remainder of current transaction.
bestRowUnknown
  BEST ROW PSEUDO_COLUMN - may or may not be pseudo column.
columnNoNulls
  COLUMN NULLABLE - might not allow NULL values.
columnNullable
  COLUMN NULLABLE - definitely allows NULL values.
columnNullableUnknown
  COLUMN NULLABLE - nullability unknown.
importedKeyCascade
  IMPORT KEY UPDATE_RULE and DELETE_RULE - for update, change imported key to agree with primary key update; for delete, delete rows that import a deleted key.
importedKeyInitiallyDeferred
  IMPORT KEY DEFERRABILITY - see SQL92 for definition
importedKeyInitiallyImmediate
  IMPORT KEY DEFERRABILITY - see SQL92 for definition
importedKeyNoAction
  IMPORT KEY UPDATE_RULE and DELETE_RULE - do not allow update or delete of primary key if it has been imported.
importedKeyNotDeferrable
  IMPORT KEY DEFERRABILITY - see SQL92 for definition
importedKeyRestrict
  IMPORT KEY UPDATE_RULE and DELETE_RULE - do not allow update or delete of primary key if it has been imported.
importedKeySetDefault
  IMPORT KEY UPDATE_RULE and DELETE_RULE - change imported key to default values if its primary key has been updated or deleted.
importedKeySetNull
  IMPORT KEY UPDATE_RULE and DELETE_RULE - change imported key to NULL if its primary key has been updated or deleted.
procedureColumnIn
  COLUMN_TYPE - IN parameter.
procedureColumnInOut
  COLUMN_TYPE - INOUT parameter.
procedureColumnOut
  COLUMN_TYPE - OUT parameter.
procedureColumnResult
  COLUMN_TYPE - result column in ResultSet.
procedureColumnReturn
  COLUMN_TYPE - procedure return value.
procedureColumnUnknown
  COLUMN_TYPE - nobody knows.
procedureNoNulls
  TYPE NULLABLE - does not allow NULL values.
procedureNoResult
  PROCEDURE_TYPE - Does not return a result.
procedureNullable
  TYPE NULLABLE - allows NULL values.
procedureNullableUnknown
  TYPE NULLABLE - nullability unknown.
procedureResultUnknown
  PROCEDURE_TYPE - May return a result.
procedureReturnsResult
  PROCEDURE_TYPE - Returns a result.
tableIndexClustered
  INDEX INFO TYPE - this identifies a clustered index
tableIndexHashed
  INDEX INFO TYPE - this identifies a hashed index
tableIndexOther
  INDEX INFO TYPE - this identifies some other form of index
tableIndexStatistic
  INDEX INFO TYPE - this identifies table statistics that are returned in conjuction with a table's index descriptions
typeNoNulls
  TYPE NULLABLE - does not allow NULL values.
typeNullable
  TYPE NULLABLE - allows NULL values.
typeNullableUnknown
  TYPE NULLABLE - nullability unknown.
typePredBasic
  TYPE INFO SEARCHABLE - Supported except for WHERE ..
typePredChar
  TYPE INFO SEARCHABLE - Only supported with WHERE ..
typePredNone
  TYPE INFO SEARCHABLE - No support.
typeSearchable
  TYPE INFO SEARCHABLE - Supported for all WHERE ...
versionColumnNotPseudo
  VERSION COLUMNS PSEUDO_COLUMN - is NOT a pseudo column.
versionColumnPseudo
  VERSION COLUMNS PSEUDO_COLUMN - is a pseudo column.
versionColumnUnknown
  VERSION COLUMNS PSEUDO_COLUMN - may or may not be pseudo column.

##

allProceduresAreCallable()
  Can all the procedures returned by getProcedures be called by the current user?
allTablesAreSelectable()
  Can all the tables returned by getTable be SELECTed by the current user?
dataDefinitionCausesTransactionCommit()
  Does a data definition statement within a transaction force the transaction to commit?
dataDefinitionIgnoredInTransactions()
  Is a data definition statement within a transaction ignored?
doesMaxRowSizeIncludeBlobs()
  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
getBestRowIdentifier(String, String, String, int, boolean)
  Get a description of a table's optimal set of columns that uniquely identifies a row.
getCatalogs()
  Get the catalog names available in this database.
getCatalogSeparator()
  What's the separator between catalog and table name?
getCatalogTerm()
  What's the database vendor's preferred term for "catalog"?
getColumnPrivileges(String, String, String, String)
  Get a description of the access rights for a table's columns.
getColumns(String, String, String, String)
  Get a description of table columns available in a catalog.
getCrossReference(String, String, String, String, String, String)
  Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.
getDatabaseProductName()
  What's the name of this database product?
getDatabaseProductVersion()
  What's the version of this database product?
getDefaultTransactionIsolation()
  What's the database's default transaction isolation level? The values are defined in java.sql.Connection.
getDriverMajorVersion()
  What's this JDBC driver's major version number?
getDriverMinorVersion()
  What's this JDBC driver's minor version number?
getDriverName()
  What's the name of this JDBC driver?
getDriverVersion()
  What's the version of this JDBC driver?
getExportedKeys(String, String, String)
  Get a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
getExtraNameCharacters()
  Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
getIdentifierQuoteString()
  What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported.
getImportedKeys(String, String, String)
  Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
getIndexInfo(String, String, String, boolean, boolean)
  Get a description of a table's indices and statistics.
getMaxBinaryLiteralLength()
  How many hex characters can you have in an inline binary literal?
getMaxCatalogNameLength()
  What's the maximum length of a catalog name?
getMaxCharLiteralLength()
  What's the max length for a character literal?
getMaxColumnNameLength()
  What's the limit on column name length?
getMaxColumnsInGroupBy()
  What's the maximum number of columns in a "GROUP BY" clause?
getMaxColumnsInIndex()
  What's the maximum number of columns allowed in an index?
getMaxColumnsInOrderBy()
  What's the maximum number of columns in an "ORDER BY" clause?
getMaxColumnsInSelect()
  What's the maximum number of columns in a "SELECT" list?
getMaxColumnsInTable()
  What's the maximum number of columns in a table?
getMaxConnections()
  How many active connections can we have at a time to this database?
getMaxCursorNameLength()
  What's the maximum cursor name length?
getMaxIndexLength()
  What's the maximum length of an index (in bytes)?
getMaxProcedureNameLength()
  What's the maximum length of a procedure name?
getMaxRowSize()
  What's the maximum length of a single row?
getMaxSchemaNameLength()
  What's the maximum length allowed for a schema name?
getMaxStatementLength()
  What's the maximum length of a SQL statement?
getMaxStatements()
  How many active statements can we have open at one time to this database?
getMaxTableNameLength()
  What's the maximum length of a table name?
getMaxTablesInSelect()
  What's the maximum number of tables in a SELECT?
getMaxUserNameLength()
  What's the maximum length of a user name?
getNumericFunctions()
  Get a comma separated list of math functions.
getPrimaryKeys(String, String, String)
  Get a description of a table's primary key columns.
getProcedureColumns(String, String, String, String)
  Get a description of a catalog's stored procedure parameters and result columns.
getProcedures(String, String, String)
  Get a description of stored procedures available in a catalog.
getProcedureTerm()
  What's the database vendor's preferred term for "procedure"?
getSchemas()
  Get the schema names available in this database.
getSchemaTerm()
  What's the database vendor's preferred term for "schema"?
getSearchStringEscape()
  This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.
getSQLKeywords()
  Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
getStringFunctions()
  Get a comma separated list of string functions.
getSystemFunctions()
  Get a comma separated list of system functions.
getTablePrivileges(String, String, String)
  Get a description of the access rights for each table available in a catalog.
getTables(String, String, String, String[])
  Get a description of tables available in a catalog.
getTableTypes()
  Get the table types available in this database.
getTimeDateFunctions()
  Get a comma separated list of time and date functions.
getTypeInfo()
  Get a description of all the standard SQL types supported by this database.
getURL()
  What's the url for this database?
getUserName()
  What's our user name as known to the database?
getVersionColumns(String, String, String)
  Get a description of a table's columns that are automatically updated when any value in a row is updated.
isCatalogAtStart()
  Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
isReadOnly()
  Is the database in read-only mode?
nullPlusNonNullIsNull()
  Are concatenations between NULL and non-NULL values NULL? A JDBC-Compliant driver always returns true.
nullsAreSortedAtEnd()
  Are NULL values sorted at the end regardless of sort order?
nullsAreSortedAtStart()
  Are NULL values sorted at the start regardless of sort order?
nullsAreSortedHigh()
  Are NULL values sorted high?
nullsAreSortedLow()
  Are NULL values sorted low?
storesLowerCaseIdentifiers()
  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
storesLowerCaseQuotedIdentifiers()
  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
storesMixedCaseIdentifiers()
  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
storesMixedCaseQuotedIdentifiers()
  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
storesUpperCaseIdentifiers()
  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
storesUpperCaseQuotedIdentifiers()
  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
supportsAlterTableWithAddColumn()
  Is "ALTER TABLE" with add column supported?
supportsAlterTableWithDropColumn()
  Is "ALTER TABLE" with drop column supported?
supportsANSI92EntryLevelSQL()
  Is the ANSI92 entry level SQL grammar supported? All JDBC-Compliant drivers must return true.
supportsANSI92FullSQL()
  Is the ANSI92 full SQL grammar supported?
supportsANSI92IntermediateSQL()
  Is the ANSI92 intermediate SQL grammar supported?
supportsCatalogsInDataManipulation()
  Can a catalog name be used in a data manipulation statement?
supportsCatalogsInIndexDefinitions()
  Can a catalog name be used in an index definition statement?
supportsCatalogsInPrivilegeDefinitions()
  Can a catalog name be used in a privilege definition statement?
supportsCatalogsInProcedureCalls()
  Can a catalog name be used in a procedure call statement?
supportsCatalogsInTableDefinitions()
  Can a catalog name be used in a table definition statement?
supportsColumnAliasing()
  Is column aliasing supported?

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required.

supportsConvert()
  Is the CONVERT function between SQL types supported?
supportsConvert(int, int)
  Is CONVERT between the given SQL types supported?
supportsCoreSQLGrammar()
  Is the ODBC Core SQL grammar supported?
supportsCorrelatedSubqueries()
  Are correlated subqueries supported? A JDBC-Compliant driver always returns true.
supportsDataDefinitionAndDataManipulationTransactions()
  Are both data definition and data manipulation statements within a transaction supported?
supportsDataManipulationTransactionsOnly()
  Are only data manipulation statements within a transaction supported?
supportsDifferentTableCorrelationNames()
  If table correlation names are supported, are they restricted to be different from the names of the tables?
supportsExpressionsInOrderBy()
  Are expressions in "ORDER BY" lists supported?
supportsExtendedSQLGrammar()
  Is the ODBC Extended SQL grammar supported?
supportsFullOuterJoins()
  Are full nested outer joins supported?
supportsGroupBy()
  Is some form of "GROUP BY" clause supported?
supportsGroupByBeyondSelect()
  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
supportsGroupByUnrelated()
  Can a "GROUP BY" clause use columns not in the SELECT?
supportsIntegrityEnhancementFacility()
  Is the SQL Integrity Enhancement Facility supported?
supportsLikeEscapeClause()
  Is the escape character in "LIKE" clauses supported? A JDBC-Compliant driver always returns true.
supportsLimitedOuterJoins()
  Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
supportsMinimumSQLGrammar()
  Is the ODBC Minimum SQL grammar supported? All JDBC-Compliant drivers must return true.
supportsMixedCaseIdentifiers()
  Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC-Compliant driver will always return false.
supportsMixedCaseQuotedIdentifiers()
  Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC-Compliant driver will always return true.
supportsMultipleResultSets()
  Are multiple ResultSets from a single execute supported?
supportsMultipleTransactions()
  Can we have multiple transactions open at once (on different connections)?
supportsNonNullableColumns()
  Can columns be defined as non-nullable? A JDBC-Compliant driver always returns true.
supportsOpenCursorsAcrossCommit()
  Can cursors remain open across commits?
supportsOpenCursorsAcrossRollback()
  Can cursors remain open across rollbacks?
supportsOpenStatementsAcrossCommit()
  Can statements remain open across commits?
supportsOpenStatementsAcrossRollback()
  Can statements remain open across rollbacks?
supportsOrderByUnrelated()
  Can an "ORDER BY" clause use columns not in the SELECT?
supportsOuterJoins()
  Is some form of outer join supported?
supportsPositionedDelete()
  Is positioned DELETE supported?
supportsPositionedUpdate()
  Is positioned UPDATE supported?
supportsSchemasInDataManipulation()
  Can a schema name be used in a data manipulation statement?
supportsSchemasInIndexDefinitions()
  Can a schema name be used in an index definition statement?
supportsSchemasInPrivilegeDefinitions()
  Can a schema name be used in a privilege definition statement?
supportsSchemasInProcedureCalls()
  Can a schema name be used in a procedure call statement?
supportsSchemasInTableDefinitions()
  Can a schema name be used in a table definition statement?
supportsSelectForUpdate()
  Is SELECT for UPDATE supported?
supportsStoredProcedures()
  Are stored procedure calls using the stored procedure escape syntax supported?
supportsSubqueriesInComparisons()
  Are subqueries in comparison expressions supported? A JDBC-Compliant driver always returns true.
supportsSubqueriesInExists()
  Are subqueries in 'exists' expressions supported? A JDBC-Compliant driver always returns true.
supportsSubqueriesInIns()
  Are subqueries in 'in' statements supported? A JDBC-Compliant driver always returns true.
supportsSubqueriesInQuantifieds()
  Are subqueries in quantified expressions supported? A JDBC-Compliant driver always returns true.
supportsTableCorrelationNames()
  Are table correlation names supported? A JDBC-Compliant driver always returns true.
supportsTransactionIsolationLevel(int)
  Does the database support the given transaction isolation level?
supportsTransactions()
  Are transactions supported? If not, commit is a noop and the isolation level is TRANSACTION_NONE.
supportsUnion()
  Is SQL UNION supported?
supportsUnionAll()
  Is SQL UNION ALL supported?
usesLocalFilePerTable()
  Does the database use a file for each table?
usesLocalFiles()
  Does the database store tables in a local file?

##

procedureResultUnknown

     public static final int procedureResultUnknown

  PROCEDURE_TYPE - May return a result.

procedureNoResult

     public static final int procedureNoResult

  PROCEDURE_TYPE - Does not return a result.

procedureReturnsResult

     public static final int procedureReturnsResult

  PROCEDURE_TYPE - Returns a result.

procedureColumnUnknown

     public static final int procedureColumnUnknown

  COLUMN_TYPE - nobody knows.

procedureColumnIn

     public static final int procedureColumnIn

  COLUMN_TYPE - IN parameter.

procedureColumnInOut

     public static final int procedureColumnInOut

  COLUMN_TYPE - INOUT parameter.

procedureColumnOut

     public static final int procedureColumnOut

  COLUMN_TYPE - OUT parameter.

procedureColumnReturn

     public static final int procedureColumnReturn

  COLUMN_TYPE - procedure return value.

procedureColumnResult

     public static final int procedureColumnResult

  COLUMN_TYPE - result column in ResultSet.

procedureNoNulls

     public static final int procedureNoNulls

  TYPE NULLABLE - does not allow NULL values.

procedureNullable

     public static final int procedureNullable

  TYPE NULLABLE - allows NULL values.

procedureNullableUnknown

     public static final int procedureNullableUnknown

  TYPE NULLABLE - nullability unknown.

columnNoNulls

     public static final int columnNoNulls

  COLUMN NULLABLE - might not allow NULL values.

columnNullable

     public static final int columnNullable

  COLUMN NULLABLE - definitely allows NULL values.

columnNullableUnknown

     public static final int columnNullableUnknown

  COLUMN NULLABLE - nullability unknown.

bestRowTemporary

     public static final int bestRowTemporary

  BEST ROW SCOPE - very temporary, while using row.

bestRowTransaction

     public static final int bestRowTransaction

  BEST ROW SCOPE - valid for remainder of current transaction.

bestRowSession

     public static final int bestRowSession

  BEST ROW SCOPE - valid for remainder of current session.

bestRowUnknown

     public static final int bestRowUnknown

  BEST ROW PSEUDO_COLUMN - may or may not be pseudo column.

bestRowNotPseudo

     public static final int bestRowNotPseudo

  BEST ROW PSEUDO_COLUMN - is NOT a pseudo column.

bestRowPseudo

     public static final int bestRowPseudo

  BEST ROW PSEUDO_COLUMN - is a pseudo column.

versionColumnUnknown

     public static final int versionColumnUnknown

  VERSION COLUMNS PSEUDO_COLUMN - may or may not be pseudo column.

versionColumnNotPseudo

     public static final int versionColumnNotPseudo

  VERSION COLUMNS PSEUDO_COLUMN - is NOT a pseudo column.

versionColumnPseudo

     public static final int versionColumnPseudo

  VERSION COLUMNS PSEUDO_COLUMN - is a pseudo column.

importedKeyCascade

     public static final int importedKeyCascade

  IMPORT KEY UPDATE_RULE and DELETE_RULE - for update, change imported key to agree with primary key update; for delete, delete rows that import a deleted key.

importedKeyRestrict

     public static final int importedKeyRestrict

  IMPORT KEY UPDATE_RULE and DELETE_RULE - do not allow update or delete of primary key if it has been imported.

importedKeySetNull

     public static final int importedKeySetNull

  IMPORT KEY UPDATE_RULE and DELETE_RULE - change imported key to NULL if its primary key has been updated or deleted.

importedKeyNoAction

     public static final int importedKeyNoAction

  IMPORT KEY UPDATE_RULE and DELETE_RULE - do not allow update or delete of primary key if it has been imported.

importedKeySetDefault

     public static final int importedKeySetDefault

  IMPORT KEY UPDATE_RULE and DELETE_RULE - change imported key to default values if its primary key has been updated or deleted.

importedKeyInitiallyDeferred

     public static final int importedKeyInitiallyDeferred

  IMPORT KEY DEFERRABILITY - see SQL92 for definition

importedKeyInitiallyImmediate

     public static final int importedKeyInitiallyImmediate

  IMPORT KEY DEFERRABILITY - see SQL92 for definition

importedKeyNotDeferrable

     public static final int importedKeyNotDeferrable

  IMPORT KEY DEFERRABILITY - see SQL92 for definition

typeNoNulls

     public static final int typeNoNulls

  TYPE NULLABLE - does not allow NULL values.

typeNullable

     public static final int typeNullable

  TYPE NULLABLE - allows NULL values.

typeNullableUnknown

     public static final int typeNullableUnknown

  TYPE NULLABLE - nullability unknown.

typePredNone

     public static final int typePredNone

  TYPE INFO SEARCHABLE - No support.

typePredChar

     public static final int typePredChar

  TYPE INFO SEARCHABLE - Only supported with WHERE .. LIKE.

typePredBasic

     public static final int typePredBasic

  TYPE INFO SEARCHABLE - Supported except for WHERE .. LIKE.

typeSearchable

     public static final int typeSearchable

  TYPE INFO SEARCHABLE - Supported for all WHERE ...

tableIndexStatistic

     public static final short tableIndexStatistic

  INDEX INFO TYPE - this identifies table statistics that are returned in conjuction with a table's index descriptions

tableIndexClustered

     public static final short tableIndexClustered

  INDEX INFO TYPE - this identifies a clustered index

tableIndexHashed

     public static final short tableIndexHashed

  INDEX INFO TYPE - this identifies a hashed index

tableIndexOther

     public static final short tableIndexOther

  INDEX INFO TYPE - this identifies some other form of index

##

allProceduresAreCallable

     public abstract boolean allProceduresAreCallable() throws SQLException

  Can all the procedures returned by getProcedures be called by the current user?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

allTablesAreSelectable

     public abstract boolean allTablesAreSelectable() throws SQLException

  Can all the tables returned by getTable be SELECTed by the current user?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getURL

     public abstract String getURL() throws SQLException

  What's the url for this database?

  Returns:
    the url or null if it can't be generated
  Throws: SQLException
    if a database-access error occurs.

getUserName

     public abstract String getUserName() throws SQLException

  What's our user name as known to the database?

  Returns:
    our database user name
  Throws: SQLException
    if a database-access error occurs.

isReadOnly

     public abstract boolean isReadOnly() throws SQLException

  Is the database in read-only mode?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

nullsAreSortedHigh

     public abstract boolean nullsAreSortedHigh() throws SQLException

  Are NULL values sorted high?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

nullsAreSortedLow

     public abstract boolean nullsAreSortedLow() throws SQLException

  Are NULL values sorted low?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

nullsAreSortedAtStart

     public abstract boolean nullsAreSortedAtStart() throws SQLException

  Are NULL values sorted at the start regardless of sort order?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

nullsAreSortedAtEnd

     public abstract boolean nullsAreSortedAtEnd() throws SQLException

  Are NULL values sorted at the end regardless of sort order?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getDatabaseProductName

     public abstract String getDatabaseProductName() throws SQLException

  What's the name of this database product?

  Returns:
    database product name
  Throws: SQLException
    if a database-access error occurs.

getDatabaseProductVersion

     public abstract String getDatabaseProductVersion() throws SQLException

  What's the version of this database product?

  Returns:
    database version
  Throws: SQLException
    if a database-access error occurs.

getDriverName

     public abstract String getDriverName() throws SQLException

  What's the name of this JDBC driver?

  Returns:
    JDBC driver name
  Throws: SQLException
    if a database-access error occurs.

getDriverVersion

     public abstract String getDriverVersion() throws SQLException

  What's the version of this JDBC driver?

  Returns:
    JDBC driver version
  Throws: SQLException
    if a database-access error occurs.

getDriverMajorVersion

     public abstract int getDriverMajorVersion()

  What's this JDBC driver's major version number?

  Returns:
    JDBC driver major version

getDriverMinorVersion

     public abstract int getDriverMinorVersion()

  What's this JDBC driver's minor version number?

  Returns:
    JDBC driver minor version number

usesLocalFiles

     public abstract boolean usesLocalFiles() throws SQLException

  Does the database store tables in a local file?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

usesLocalFilePerTable

     public abstract boolean usesLocalFilePerTable() throws SQLException

  Does the database use a file for each table?

  Returns:
    true if the database uses a local file for each table
  Throws: SQLException
    if a database-access error occurs.

supportsMixedCaseIdentifiers

     public abstract boolean supportsMixedCaseIdentifiers() throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC-Compliant driver will always return false.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesUpperCaseIdentifiers

     public abstract boolean storesUpperCaseIdentifiers() throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesLowerCaseIdentifiers

     public abstract boolean storesLowerCaseIdentifiers() throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesMixedCaseIdentifiers

     public abstract boolean storesMixedCaseIdentifiers() throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsMixedCaseQuotedIdentifiers

     public abstract boolean supportsMixedCaseQuotedIdentifiers() throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC-Compliant driver will always return true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesUpperCaseQuotedIdentifiers

     public abstract boolean storesUpperCaseQuotedIdentifiers() throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesLowerCaseQuotedIdentifiers

     public abstract boolean storesLowerCaseQuotedIdentifiers() throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

storesMixedCaseQuotedIdentifiers

     public abstract boolean storesMixedCaseQuotedIdentifiers() throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getIdentifierQuoteString

     public abstract String getIdentifierQuoteString() throws SQLException

  What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC-Compliant driver always uses a double quote character.

  Returns:
    the quoting string
  Throws: SQLException
    if a database-access error occurs.

getSQLKeywords

     public abstract String getSQLKeywords() throws SQLException

  Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.

  Returns:
    the list
  Throws: SQLException
    if a database-access error occurs.

getNumericFunctions

     public abstract String getNumericFunctions() throws SQLException

  Get a comma separated list of math functions.

  Returns:
    the list
  Throws: SQLException
    if a database-access error occurs.

getStringFunctions

     public abstract String getStringFunctions() throws SQLException

  Get a comma separated list of string functions.

  Returns:
    the list
  Throws: SQLException
    if a database-access error occurs.

getSystemFunctions

     public abstract String getSystemFunctions() throws SQLException

  Get a comma separated list of system functions.

  Returns:
    the list
  Throws: SQLException
    if a database-access error occurs.

getTimeDateFunctions

     public abstract String getTimeDateFunctions() throws SQLException

  Get a comma separated list of time and date functions.

  Returns:
    the list
  Throws: SQLException
    if a database-access error occurs.

getSearchStringEscape

     public abstract String getSearchStringEscape() throws SQLException

  This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

  The '_' character represents any single character.

  The '%' character represents any sequence of zero or more characters.

  Returns:
    the string used to escape wildcard characters
  Throws: SQLException
    if a database-access error occurs.

getExtraNameCharacters

     public abstract String getExtraNameCharacters() throws SQLException

  Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).

  Returns:
    the string containing the extra characters
  Throws: SQLException
    if a database-access error occurs.

supportsAlterTableWithAddColumn

     public abstract boolean supportsAlterTableWithAddColumn() throws SQLException

  Is "ALTER TABLE" with add column supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsAlterTableWithDropColumn

     public abstract boolean supportsAlterTableWithDropColumn() throws SQLException

  Is "ALTER TABLE" with drop column supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsColumnAliasing

     public abstract boolean supportsColumnAliasing() throws SQLException

  Is column aliasing supported?

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

nullPlusNonNullIsNull

     public abstract boolean nullPlusNonNullIsNull() throws SQLException

  Are concatenations between NULL and non-NULL values NULL? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsConvert

     public abstract boolean supportsConvert() throws SQLException

  Is the CONVERT function between SQL types supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsConvert

     public abstract boolean supportsConvert(int fromType,
                                             int toType) throws SQLException

  Is CONVERT between the given SQL types supported?

  Parameters:
    fromType - the type to convert from
    toType - the type to convert to
  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    Types

supportsTableCorrelationNames

     public abstract boolean supportsTableCorrelationNames() throws SQLException

  Are table correlation names supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsDifferentTableCorrelationNames

     public abstract boolean supportsDifferentTableCorrelationNames() throws SQLException

  If table correlation names are supported, are they restricted to be different from the names of the tables?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsExpressionsInOrderBy

     public abstract boolean supportsExpressionsInOrderBy() throws SQLException

  Are expressions in "ORDER BY" lists supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsOrderByUnrelated

     public abstract boolean supportsOrderByUnrelated() throws SQLException

  Can an "ORDER BY" clause use columns not in the SELECT?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsGroupBy

     public abstract boolean supportsGroupBy() throws SQLException

  Is some form of "GROUP BY" clause supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsGroupByUnrelated

     public abstract boolean supportsGroupByUnrelated() throws SQLException

  Can a "GROUP BY" clause use columns not in the SELECT?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsGroupByBeyondSelect

     public abstract boolean supportsGroupByBeyondSelect() throws SQLException

  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsLikeEscapeClause

     public abstract boolean supportsLikeEscapeClause() throws SQLException

  Is the escape character in "LIKE" clauses supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsMultipleResultSets

     public abstract boolean supportsMultipleResultSets() throws SQLException

  Are multiple ResultSets from a single execute supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsMultipleTransactions

     public abstract boolean supportsMultipleTransactions() throws SQLException

  Can we have multiple transactions open at once (on different connections)?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsNonNullableColumns

     public abstract boolean supportsNonNullableColumns() throws SQLException

  Can columns be defined as non-nullable? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsMinimumSQLGrammar

     public abstract boolean supportsMinimumSQLGrammar() throws SQLException

  Is the ODBC Minimum SQL grammar supported? All JDBC-Compliant drivers must return true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCoreSQLGrammar

     public abstract boolean supportsCoreSQLGrammar() throws SQLException

  Is the ODBC Core SQL grammar supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsExtendedSQLGrammar

     public abstract boolean supportsExtendedSQLGrammar() throws SQLException

  Is the ODBC Extended SQL grammar supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsANSI92EntryLevelSQL

     public abstract boolean supportsANSI92EntryLevelSQL() throws SQLException

  Is the ANSI92 entry level SQL grammar supported? All JDBC-Compliant drivers must return true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsANSI92IntermediateSQL

     public abstract boolean supportsANSI92IntermediateSQL() throws SQLException

  Is the ANSI92 intermediate SQL grammar supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsANSI92FullSQL

     public abstract boolean supportsANSI92FullSQL() throws SQLException

  Is the ANSI92 full SQL grammar supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsIntegrityEnhancementFacility

     public abstract boolean supportsIntegrityEnhancementFacility() throws SQLException

  Is the SQL Integrity Enhancement Facility supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsOuterJoins

     public abstract boolean supportsOuterJoins() throws SQLException

  Is some form of outer join supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsFullOuterJoins

     public abstract boolean supportsFullOuterJoins() throws SQLException

  Are full nested outer joins supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsLimitedOuterJoins

     public abstract boolean supportsLimitedOuterJoins() throws SQLException

  Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getSchemaTerm

     public abstract String getSchemaTerm() throws SQLException

  What's the database vendor's preferred term for "schema"?

  Returns:
    the vendor term
  Throws: SQLException
    if a database-access error occurs.

getProcedureTerm

     public abstract String getProcedureTerm() throws SQLException

  What's the database vendor's preferred term for "procedure"?

  Returns:
    the vendor term
  Throws: SQLException
    if a database-access error occurs.

getCatalogTerm

     public abstract String getCatalogTerm() throws SQLException

  What's the database vendor's preferred term for "catalog"?

  Returns:
    the vendor term
  Throws: SQLException
    if a database-access error occurs.

isCatalogAtStart

     public abstract boolean isCatalogAtStart() throws SQLException

  Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)

  Returns:
    true if it appears at the start
  Throws: SQLException
    if a database-access error occurs.

getCatalogSeparator

     public abstract String getCatalogSeparator() throws SQLException

  What's the separator between catalog and table name?

  Returns:
    the separator string
  Throws: SQLException
    if a database-access error occurs.

supportsSchemasInDataManipulation

     public abstract boolean supportsSchemasInDataManipulation() throws SQLException

  Can a schema name be used in a data manipulation statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSchemasInProcedureCalls

     public abstract boolean supportsSchemasInProcedureCalls() throws SQLException

  Can a schema name be used in a procedure call statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSchemasInTableDefinitions

     public abstract boolean supportsSchemasInTableDefinitions() throws SQLException

  Can a schema name be used in a table definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSchemasInIndexDefinitions

     public abstract boolean supportsSchemasInIndexDefinitions() throws SQLException

  Can a schema name be used in an index definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSchemasInPrivilegeDefinitions

     public abstract boolean supportsSchemasInPrivilegeDefinitions() throws SQLException

  Can a schema name be used in a privilege definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCatalogsInDataManipulation

     public abstract boolean supportsCatalogsInDataManipulation() throws SQLException

  Can a catalog name be used in a data manipulation statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCatalogsInProcedureCalls

     public abstract boolean supportsCatalogsInProcedureCalls() throws SQLException

  Can a catalog name be used in a procedure call statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCatalogsInTableDefinitions

     public abstract boolean supportsCatalogsInTableDefinitions() throws SQLException

  Can a catalog name be used in a table definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCatalogsInIndexDefinitions

     public abstract boolean supportsCatalogsInIndexDefinitions() throws SQLException

  Can a catalog name be used in an index definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCatalogsInPrivilegeDefinitions

     public abstract boolean supportsCatalogsInPrivilegeDefinitions() throws SQLException

  Can a catalog name be used in a privilege definition statement?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsPositionedDelete

     public abstract boolean supportsPositionedDelete() throws SQLException

  Is positioned DELETE supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsPositionedUpdate

     public abstract boolean supportsPositionedUpdate() throws SQLException

  Is positioned UPDATE supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSelectForUpdate

     public abstract boolean supportsSelectForUpdate() throws SQLException

  Is SELECT for UPDATE supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsStoredProcedures

     public abstract boolean supportsStoredProcedures() throws SQLException

  Are stored procedure calls using the stored procedure escape syntax supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSubqueriesInComparisons

     public abstract boolean supportsSubqueriesInComparisons() throws SQLException

  Are subqueries in comparison expressions supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSubqueriesInExists

     public abstract boolean supportsSubqueriesInExists() throws SQLException

  Are subqueries in 'exists' expressions supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSubqueriesInIns

     public abstract boolean supportsSubqueriesInIns() throws SQLException

  Are subqueries in 'in' statements supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsSubqueriesInQuantifieds

     public abstract boolean supportsSubqueriesInQuantifieds() throws SQLException

  Are subqueries in quantified expressions supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsCorrelatedSubqueries

     public abstract boolean supportsCorrelatedSubqueries() throws SQLException

  Are correlated subqueries supported? A JDBC-Compliant driver always returns true.

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsUnion

     public abstract boolean supportsUnion() throws SQLException

  Is SQL UNION supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsUnionAll

     public abstract boolean supportsUnionAll() throws SQLException

  Is SQL UNION ALL supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsOpenCursorsAcrossCommit

     public abstract boolean supportsOpenCursorsAcrossCommit() throws SQLException

  Can cursors remain open across commits?

  Returns:
    true if cursors always remain open; false if they might not remain open
  Throws: SQLException
    if a database-access error occurs.

supportsOpenCursorsAcrossRollback

     public abstract boolean supportsOpenCursorsAcrossRollback() throws SQLException

  Can cursors remain open across rollbacks?

  Returns:
    true if cursors always remain open; false if they might not remain open
  Throws: SQLException
    if a database-access error occurs.

supportsOpenStatementsAcrossCommit

     public abstract boolean supportsOpenStatementsAcrossCommit() throws SQLException

  Can statements remain open across commits?

  Returns:
    true if statements always remain open; false if they might not remain open
  Throws: SQLException
    if a database-access error occurs.

supportsOpenStatementsAcrossRollback

     public abstract boolean supportsOpenStatementsAcrossRollback() throws SQLException

  Can statements remain open across rollbacks?

  Returns:
    true if statements always remain open; false if they might not remain open
  Throws: SQLException
    if a database-access error occurs.

getMaxBinaryLiteralLength

     public abstract int getMaxBinaryLiteralLength() throws SQLException

  How many hex characters can you have in an inline binary literal?

  Returns:
    max literal length
  Throws: SQLException
    if a database-access error occurs.

getMaxCharLiteralLength

     public abstract int getMaxCharLiteralLength() throws SQLException

  What's the max length for a character literal?

  Returns:
    max literal length
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnNameLength

     public abstract int getMaxColumnNameLength() throws SQLException

  What's the limit on column name length?

  Returns:
    max literal length
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnsInGroupBy

     public abstract int getMaxColumnsInGroupBy() throws SQLException

  What's the maximum number of columns in a "GROUP BY" clause?

  Returns:
    max number of columns
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnsInIndex

     public abstract int getMaxColumnsInIndex() throws SQLException

  What's the maximum number of columns allowed in an index?

  Returns:
    max columns
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnsInOrderBy

     public abstract int getMaxColumnsInOrderBy() throws SQLException

  What's the maximum number of columns in an "ORDER BY" clause?

  Returns:
    max columns
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnsInSelect

     public abstract int getMaxColumnsInSelect() throws SQLException

  What's the maximum number of columns in a "SELECT" list?

  Returns:
    max columns
  Throws: SQLException
    if a database-access error occurs.

getMaxColumnsInTable

     public abstract int getMaxColumnsInTable() throws SQLException

  What's the maximum number of columns in a table?

  Returns:
    max columns
  Throws: SQLException
    if a database-access error occurs.

getMaxConnections

     public abstract int getMaxConnections() throws SQLException

  How many active connections can we have at a time to this database?

  Returns:
    max connections
  Throws: SQLException
    if a database-access error occurs.

getMaxCursorNameLength

     public abstract int getMaxCursorNameLength() throws SQLException

  What's the maximum cursor name length?

  Returns:
    max cursor name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxIndexLength

     public abstract int getMaxIndexLength() throws SQLException

  What's the maximum length of an index (in bytes)?

  Returns:
    max index length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxSchemaNameLength

     public abstract int getMaxSchemaNameLength() throws SQLException

  What's the maximum length allowed for a schema name?

  Returns:
    max name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxProcedureNameLength

     public abstract int getMaxProcedureNameLength() throws SQLException

  What's the maximum length of a procedure name?

  Returns:
    max name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxCatalogNameLength

     public abstract int getMaxCatalogNameLength() throws SQLException

  What's the maximum length of a catalog name?

  Returns:
    max name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxRowSize

     public abstract int getMaxRowSize() throws SQLException

  What's the maximum length of a single row?

  Returns:
    max row size in bytes
  Throws: SQLException
    if a database-access error occurs.

doesMaxRowSizeIncludeBlobs

     public abstract boolean doesMaxRowSizeIncludeBlobs() throws SQLException

  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getMaxStatementLength

     public abstract int getMaxStatementLength() throws SQLException

  What's the maximum length of a SQL statement?

  Returns:
    max length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxStatements

     public abstract int getMaxStatements() throws SQLException

  How many active statements can we have open at one time to this database?

  Returns:
    the maximum
  Throws: SQLException
    if a database-access error occurs.

getMaxTableNameLength

     public abstract int getMaxTableNameLength() throws SQLException

  What's the maximum length of a table name?

  Returns:
    max name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getMaxTablesInSelect

     public abstract int getMaxTablesInSelect() throws SQLException

  What's the maximum number of tables in a SELECT?

  Returns:
    the maximum
  Throws: SQLException
    if a database-access error occurs.

getMaxUserNameLength

     public abstract int getMaxUserNameLength() throws SQLException

  What's the maximum length of a user name?

  Returns:
    max name length in bytes
  Throws: SQLException
    if a database-access error occurs.

getDefaultTransactionIsolation

     public abstract int getDefaultTransactionIsolation() throws SQLException

  What's the database's default transaction isolation level? The values are defined in java.sql.Connection.

  Returns:
    the default isolation level
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    Connection

supportsTransactions

     public abstract boolean supportsTransactions() throws SQLException

  Are transactions supported? If not, commit is a noop and the isolation level is TRANSACTION_NONE.

  Returns:
    true if transactions are supported
  Throws: SQLException
    if a database-access error occurs.

supportsTransactionIsolationLevel

     public abstract boolean supportsTransactionIsolationLevel(int level) throws SQLException

  Does the database support the given transaction isolation level?

  Parameters:
    level - the values are defined in java.sql.Connection
  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    Connection

supportsDataDefinitionAndDataManipulationTransactions

     public abstract boolean supportsDataDefinitionAndDataManipulationTransactions() throws SQLException

  Are both data definition and data manipulation statements within a transaction supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

supportsDataManipulationTransactionsOnly

     public abstract boolean supportsDataManipulationTransactionsOnly() throws SQLException

  Are only data manipulation statements within a transaction supported?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

dataDefinitionCausesTransactionCommit

     public abstract boolean dataDefinitionCausesTransactionCommit() throws SQLException

  Does a data definition statement within a transaction force the transaction to commit?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

dataDefinitionIgnoredInTransactions

     public abstract boolean dataDefinitionIgnoredInTransactions() throws SQLException

  Is a data definition statement within a transaction ignored?

  Returns:
    true if so
  Throws: SQLException
    if a database-access error occurs.

getProcedures

     public abstract ResultSet getProcedures(String catalog,
                                             String schemaPattern,
                                             String procedureNamePattern) throws SQLException

  Get a description of stored procedures available in a catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schemaPattern - a schema name pattern; "" retrieves those without a schema
    procedureNamePattern - a procedure name pattern
  Returns:
    ResultSet - each row is a procedure description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getProcedureColumns

     public abstract ResultSet getProcedureColumns(String catalog,
                                                   String schemaPattern,
                                                   String procedureNamePattern,
                                                   String columnNamePattern) throws SQLException

  Get a description of a catalog's stored procedure parameters and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the ResultSet is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in ResultSet
  6. DATA_TYPE short => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL?
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schemaPattern - a schema name pattern; "" retrieves those without a schema
    procedureNamePattern - a procedure name pattern
    columnNamePattern - a column name pattern
  Returns:
    ResultSet - each row is a stored procedure parameter or column description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getTables

     public abstract ResultSet getTables(String catalog,
                                         String schemaPattern,
                                         String tableNamePattern,
                                         String types[]) throws SQLException

  Get a description of tables available in a catalog.

  Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table

  Note: Some databases may not return information for all tables.

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schemaPattern - a schema name pattern; "" retrieves those without a schema
    tableNamePattern - a table name pattern
    types - a list of table types to include; null returns all types
  Returns:
    ResultSet - each row is a table description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getSchemas

     public abstract ResultSet getSchemas() throws SQLException

  Get the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name

  Returns:
    ResultSet - each row has a single String column that is a schema name
  Throws: SQLException
    if a database-access error occurs.

getCatalogs

     public abstract ResultSet getCatalogs() throws SQLException

  Get the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name

  Returns:
    ResultSet - each row has a single String column that is a catalog name
  Throws: SQLException
    if a database-access error occurs.

getTableTypes

     public abstract ResultSet getTableTypes() throws SQLException

  Get the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

  Returns:
    ResultSet - each row has a single String column that is a table type
  Throws: SQLException
    if a database-access error occurs.

getColumns

     public abstract ResultSet getColumns(String catalog,
                                          String schemaPattern,
                                          String tableNamePattern,
                                          String columnNamePattern) throws SQLException

  Get a description of table columns available in a catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE short => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name
  7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed?
      - columnNoNulls - might not allow NULL values
      - columnNullable - definitely allows NULL values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be null)
  13. COLUMN_DEF String => default value (may be null)
  14. SQL_DATA_TYPE int => unused
  15. SQL_DATETIME_SUB int => unused
  16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int => index of column in table (starting at 1)
  18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schemaPattern - a schema name pattern; "" retrieves those without a schema
    tableNamePattern - a table name pattern
    columnNamePattern - a column name pattern
  Returns:
    ResultSet - each row is a column description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getColumnPrivileges

     public abstract ResultSet getColumnPrivileges(String catalog,
                                                   String schema,
                                                   String table,
                                                   String columnNamePattern) throws SQLException

  Get a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR => grantor of access (may be null)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name; "" retrieves those without a schema
    table - a table name
    columnNamePattern - a column name pattern
  Returns:
    ResultSet - each row is a column privilege description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getTablePrivileges

     public abstract ResultSet getTablePrivileges(String catalog,
                                                  String schemaPattern,
                                                  String tableNamePattern) throws SQLException

  Get a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this priviledge applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. GRANTOR => grantor of access (may be null)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schemaPattern - a schema name pattern; "" retrieves those without a schema
    tableNamePattern - a table name pattern
  Returns:
    ResultSet - each row is a table privilege description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getSearchStringEscape

getBestRowIdentifier

     public abstract ResultSet getBestRowIdentifier(String catalog,
                                                    String schema,
                                                    String table,
                                                    int scope,
                                                    boolean nullable) throws SQLException

  Get a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name; "" retrieves those without a schema
    table - a table name
    scope - the scope of interest; use same values as SCOPE
    nullable - include columns that are nullable?
  Returns:
    ResultSet - each row is a column description
  Throws: SQLException
    if a database-access error occurs.

getVersionColumns

     public abstract ResultSet getVersionColumns(String catalog,
                                                 String schema,
                                                 String table) throws SQLException

  Get a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name; "" retrieves those without a schema
    table - a table name
  Returns:
    ResultSet - each row is a column description
  Throws: SQLException
    if a database-access error occurs.

getPrimaryKeys

     public abstract ResultSet getPrimaryKeys(String catalog,
                                              String schema,
                                              String table) throws SQLException

  Get a description of a table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => sequence number within primary key
  6. PK_NAME String => primary key name (may be null)

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name pattern; "" retrieves those without a schema
    table - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws: SQLException
    if a database-access error occurs.

getImportedKeys

     public abstract ResultSet getImportedKeys(String catalog,
                                               String schema,
                                               String table) throws SQLException

  Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name pattern; "" retrieves those without a schema
    table - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getExportedKeys

getExportedKeys

     public abstract ResultSet getExportedKeys(String catalog,
                                               String schema,
                                               String table) throws SQLException

  Get a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name pattern; "" retrieves those without a schema
    table - a table name
  Returns:
    ResultSet - each row is a foreign key column description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getImportedKeys

getCrossReference

     public abstract ResultSet getCrossReference(String primaryCatalog,
                                                 String primarySchema,
                                                 String primaryTable,
                                                 String foreignCatalog,
                                                 String foreignSchema,
                                                 String foreignTable) throws SQLException

  Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Parameters:
    primaryCatalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    primarySchema - a schema name pattern; "" retrieves those without a schema
    primaryTable - the table name that exports the key
    foreignCatalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    foreignSchema - a schema name pattern; "" retrieves those without a schema
    foreignTable - the table name that imports the key
  Returns:
    ResultSet - each row is a foreign key column description
  Throws: SQLException
    if a database-access error occurs.
  See Also:
    getImportedKeys

getTypeInfo

     public abstract ResultSet getTypeInfo() throws SQLException

  Get a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE short => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
  6. CREATE_PARAMS String => parameters used in creating the type (may be null)
  7. NULLABLE short => can you use NULL for this type?
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive?
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
  11. FIXED_PREC_SCALE boolean => can it be a money value?
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
  13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10

  Returns:
    ResultSet - each row is a SQL type description
  Throws: SQLException
    if a database-access error occurs.

getIndexInfo

     public abstract ResultSet getIndexInfo(String catalog,
                                            String schema,
                                            String table,
                                            boolean unique,
                                            boolean approximate) throws SQLException

  Get a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be null)

  Parameters:
    catalog - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    schema - a schema name pattern; "" retrieves those without a schema
    table - a table name
    unique - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    approximate - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
  Returns:
    ResultSet - each row is an index column description
  Throws: SQLException
    if a database-access error occurs.

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.